<script lang="ts" setup>
import { useLicenseStore } from '@/stores/license'
import { useToast } from 'primevue/usetoast'
import { getErrorMessage } from '@/api/apierror'
import Button from 'primevue/button'

const toast = useToast()

const props = defineProps<{
  licenseeId: string,
  id: string,
  productName: string,
}>()

const store = useLicenseStore()

const downloadLicenseFile = async () => {
  try {
    const token = await store.checkout(props.licenseeId, props.productName, props.id)

    const element = document.createElement('a')
    element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(token))
    element.setAttribute('download', `${props.productName}_${props.id}.lic`)

    element.style.display = 'none'
    document.body.appendChild(element)

    element.click()

    document.body.removeChild(element)
  } catch (error) {
    const errorDetail = getErrorMessage(error)
    toast.add({ severity: 'error', summary: 'An error occurred', detail: errorDetail, life: 5000 })
  }
}

</script>

<template>
  <Button
    class="bg-themeblue-500 text-slate-50"
    size="small"
    icon="pi pi-download"
    aria-label="Download license file"
    :onclick="downloadLicenseFile"
    data-test="button-checkout"
  />
</template>
